;;;Created by Andr Dagenais (ADC-DAO inc.)
;;;2013-06-14
;;;Version 1.0

;;;Main program
(defun c:adcimportpoints ()

  (setq oldAttdia (getvar "ATTDIA"))
  (setq oldCmdecho (getvar "CMDECHO"))
  (setvar "ATTDIA" 0)
  (setvar "CMDECHO" 0)

  (setq strFileName (getfiled "Select a file to import:" "c:" "txt" 0))
  ;(setq strFileName "I://Prog//AutoCAD//Autolisp//Civil//Points.txt")
  (setq f (open strFileName "r"))
  (while (setq strLine (read-line f))
    (if (> (strlen strLine) 0)
      (progn
       (if (/= (substr strLine 1 1) ";")
	  (progn
	     (setq ptNo (getStringAt strLine "," 1))
	     (setq ptDescription (getStringAt strLine "," 5))
	     (setq ptx (getx strLine))
	     (setq pty (gety strLine))
	     (setq ptz (getz strLine))
	     (command "_INSERT" "ADCPoint" (strcat ptx "," pty "," ptz) "1" "1" "0" ptNo ptDescription)
	  )
	)
      )
    )
  )
  (close f)

  (setvar "ATTDIA" oldAttdia)
  (setvar "CMDECHO" oldCmdecho)

  (princ)
  
)


;;; Some library functions

(defun getStringAt (str1 str2 int1)

  (setq startPosition 0)
  (setq strTemp1 str1)
  (setq strTemp2 str1)

  (while (< startPosition int1)
    (setq strTemp1 strTemp2)
    (setq pos1 (f-charsearch strTemp1 str2))
    (if pos1
    	(setq strTemp2 (substr strTemp1 (1+ pos1)))
        (setq pos1 (1+ (strlen strTemp1)))
    )
    (setq startPosition (1+ startPosition))
  )
  
  (setq strX (substr strTemp1 1 (1- pos1)))
)  

(defun getX (strLine) ()

  (setq str1 (getStringAt strLine "," 2))
	 
)

(defun getY (strLine) ()

  (setq str1 (getStringAt strLine "," 3))
	 
)

(defun getZ (strLine) ()

  (setq str1 (getStringAt strLine "," 4))
	 
)


(defun f-charsearch (str1 str2 / bouc1 num1 str3)

   (setq num1 1)
   (setq bouc1 T)
   (while (and (/= (setq str3 (substr str1 num1 1)) "") bouc1)
      (setq num1 (1+ num1))
      (if (= str3 str2)
         (setq bouc1 nil)
      )
   )
   (if bouc1
      (eval nil)
      (1- num1)
   )
)